"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var chalk = require("chalk-pipe");
var inquirer = require("inquirer");
var Ora = require("ora");
var path = require("path");
var ImageOperations_1 = require("./Enums/ImageOperations");
var InputFormats_1 = require("./Enums/InputFormats");
var InputType_1 = require("./Enums/InputType");
var Questions_1 = require("./Questions");
var ConvertQuestions_1 = require("./Questions/ConvertQuestions");
var CropQuestions_1 = require("./Questions/CropQuestions");
var OptimizeQuestions_1 = require("./Questions/OptimizeQuestions");
var ResizeQuestions_1 = require("./Questions/ResizeQuestions");
var RotateQuestions_1 = require("./Questions/RotateQuestions");
var FileUtils_1 = require("./Utils/FileUtils");
var ImageUtils_1 = require("./Utils/ImageUtils");
var Resizer = (function () {
    function Resizer() {
        this.spinner = new Ora({ spinner: "bouncingBar" });
    }
    Resizer.prototype.main = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.askInputType()];
                    case 1:
                        _a.sent();
                        return [4, this.askImageOperations()];
                    case 2:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    Resizer.prototype.askInputFilePath = function () {
        return __awaiter(this, void 0, void 0, function () {
            var inputFilePath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, inquirer.prompt([Questions_1.default.inputFilePath])];
                    case 1:
                        inputFilePath = (_a.sent()).inputFilePath;
                        this.inputFilePath = inputFilePath;
                        return [2];
                }
            });
        });
    };
    Resizer.prototype.askOutputFilePath = function () {
        return __awaiter(this, void 0, void 0, function () {
            var outputFilePath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, inquirer.prompt([Questions_1.default.outputFilePath])];
                    case 1:
                        outputFilePath = (_a.sent()).outputFilePath;
                        this.outputFilePath = outputFilePath;
                        return [2];
                }
            });
        });
    };
    Resizer.prototype.askSuffixOrPrefix = function () {
        return __awaiter(this, void 0, void 0, function () {
            var suffixOrPrefix, _a, suffix, prefix;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4, inquirer.prompt([Questions_1.default.suffixOrPrefix])];
                    case 1:
                        suffixOrPrefix = (_b.sent()).suffixOrPrefix;
                        _a = suffixOrPrefix;
                        switch (_a) {
                            case 'suffix': return [3, 2];
                            case 'prefix': return [3, 4];
                        }
                        return [3, 6];
                    case 2: return [4, inquirer.prompt([Questions_1.default.suffix])];
                    case 3:
                        suffix = (_b.sent()).suffix;
                        this.suffix = suffix;
                        return [3, 7];
                    case 4: return [4, inquirer.prompt([Questions_1.default.prefix])];
                    case 5:
                        prefix = (_b.sent()).prefix;
                        this.prefix = prefix;
                        return [3, 7];
                    case 6: return [3, 7];
                    case 7: return [2];
                }
            });
        });
    };
    Resizer.prototype.askDirPath = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, inputDirPath, outputDirPath, foundFiles, inputInfo, msg;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4, inquirer.prompt([Questions_1.default.inputDirPath, Questions_1.default.outputDirPath])];
                    case 1:
                        _a = _b.sent(), inputDirPath = _a.inputDirPath, outputDirPath = _a.outputDirPath;
                        foundFiles = FileUtils_1.default.dirFiles(inputDirPath, FileUtils_1.default.INPUT_FORMATS);
                        this.inputDirPath = inputDirPath;
                        this.outputDirPath = outputDirPath;
                        this.inputFiles = foundFiles;
                        inputInfo = Object.keys(InputFormats_1.default)
                            .reduce(function (counts, key) {
                            var fileCount = FileUtils_1.default.filterSuffix(foundFiles, InputFormats_1.default[key]).length;
                            if (fileCount > 0) {
                                counts.push(key + ": " + fileCount);
                            }
                            return counts;
                        }, []);
                        msg = "> Number of file found: " + foundFiles.length + "\n> " + inputInfo.join(' | ');
                        console.log(chalk('royalblue.bold')(msg));
                        return [2];
                }
            });
        });
    };
    Resizer.prototype.startSpinner = function (text) {
        this.spinner.start(text);
    };
    Resizer.prototype.succedSpinner = function (text) {
        this.spinner.succeed(text);
    };
    Resizer.prototype.failSpinner = function (text) {
        this.spinner.fail(text);
    };
    Resizer.prototype.askImageOperations = function () {
        return __awaiter(this, void 0, void 0, function () {
            var operation, options, _a, _b, width, height, ignoreAspectRatio, direction, position_1, _c, inputCount, isFail, i, fileName, outputFileName, err_1, err_2;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0: return [4, inquirer.prompt([Questions_1.default.operations])];
                    case 1:
                        operation = (_d.sent()).operation;
                        _a = operation;
                        switch (_a) {
                            case ImageOperations_1.default.Optimize: return [3, 2];
                            case ImageOperations_1.default.Convert: return [3, 4];
                            case ImageOperations_1.default.Resize: return [3, 6];
                            case ImageOperations_1.default.Rotate: return [3, 10];
                            case ImageOperations_1.default.Crop: return [3, 12];
                        }
                        return [3, 18];
                    case 2: return [4, inquirer.prompt(OptimizeQuestions_1.default)];
                    case 3:
                        options = _d.sent();
                        return [3, 18];
                    case 4: return [4, inquirer.prompt(ConvertQuestions_1.default)];
                    case 5:
                        options = _d.sent();
                        return [3, 18];
                    case 6: return [4, inquirer.prompt(ResizeQuestions_1.default)];
                    case 7:
                        options = _d.sent();
                        _b = options.size.split('x')
                            .map(function (v) { return isNaN(parseInt(v, 10)) ? '' : parseInt(v, 10); }), width = _b[0], height = _b[1];
                        options.width = width;
                        options.height = height;
                        if (!(Number.isInteger(width) && Number.isInteger(height))) return [3, 9];
                        return [4, inquirer.prompt(Questions_1.default.ignoreAspectRatio)];
                    case 8:
                        ignoreAspectRatio = (_d.sent()).ignoreAspectRatio;
                        options.ignoreAspectRatio = ignoreAspectRatio;
                        _d.label = 9;
                    case 9: return [3, 18];
                    case 10: return [4, inquirer.prompt(RotateQuestions_1.default)];
                    case 11:
                        options = _d.sent();
                        return [3, 18];
                    case 12: return [4, inquirer.prompt(CropQuestions_1.default)];
                    case 13:
                        options = _d.sent();
                        if (!options.isSetDirection) return [3, 15];
                        return [4, inquirer.prompt([Questions_1.default.direction])];
                    case 14:
                        direction = (_d.sent()).direction;
                        options.direction = direction;
                        return [3, 17];
                    case 15: return [4, inquirer.prompt([Questions_1.default.x, Questions_1.default.y])];
                    case 16:
                        position_1 = _d.sent();
                        Object.keys(position_1).forEach(function (key) { return options[key] = position_1[key]; });
                        _d.label = 17;
                    case 17: return [3, 18];
                    case 18:
                        this.startSpinner('Processing…');
                        _c = this.inputType;
                        switch (_c) {
                            case InputType_1.default.Directory: return [3, 19];
                            case InputType_1.default.File: return [3, 26];
                        }
                        return [3, 30];
                    case 19:
                        inputCount = this.inputFiles.length;
                        isFail = false;
                        i = 0;
                        _d.label = 20;
                    case 20:
                        if (!(i < this.inputFiles.length)) return [3, 25];
                        fileName = this.inputFiles[i];
                        outputFileName = FileUtils_1.default.addPrefixOrSuffix(fileName, this.prefix, this.suffix);
                        if (options.outputType) {
                            outputFileName = FileUtils_1.default.changeExtension(outputFileName, options.outputType);
                        }
                        _d.label = 21;
                    case 21:
                        _d.trys.push([21, 23, , 24]);
                        options.src = path.join(this.inputDirPath, fileName);
                        options.dst = path.join(this.outputDirPath, outputFileName);
                        return [4, ImageUtils_1.default[operation](options)];
                    case 22:
                        _d.sent();
                        this.spinner.text = "Processing\u2026 (" + (i + 1) + "/" + inputCount + ") - " + outputFileName;
                        return [3, 24];
                    case 23:
                        err_1 = _d.sent();
                        isFail = true;
                        this.failSpinner('Failed.');
                        return [3, 24];
                    case 24:
                        ++i;
                        return [3, 20];
                    case 25:
                        if (!isFail) {
                            this.succedSpinner('Successfully completed.');
                        }
                        return [3, 30];
                    case 26:
                        _d.trys.push([26, 28, , 29]);
                        if (options.outputType) {
                            this.outputFilePath = FileUtils_1.default.changeExtension(this.outputFilePath, options.outputType);
                        }
                        options.src = this.inputFilePath;
                        options.dst = this.outputFilePath;
                        return [4, ImageUtils_1.default[operation](options)];
                    case 27:
                        _d.sent();
                        this.succedSpinner('Successfully completed.');
                        return [3, 29];
                    case 28:
                        err_2 = _d.sent();
                        this.failSpinner('Failed.');
                        return [3, 29];
                    case 29: return [3, 30];
                    case 30: return [2];
                }
            });
        });
    };
    Resizer.prototype.askInputType = function () {
        return __awaiter(this, void 0, void 0, function () {
            var inputType, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4, inquirer.prompt([Questions_1.default.inputType])];
                    case 1:
                        inputType = (_b.sent()).inputType;
                        this.inputType = inputType;
                        _a = inputType;
                        switch (_a) {
                            case InputType_1.default.File: return [3, 2];
                            case InputType_1.default.Directory: return [3, 5];
                        }
                        return [3, 8];
                    case 2: return [4, this.askInputFilePath()];
                    case 3:
                        _b.sent();
                        return [4, this.askOutputFilePath()];
                    case 4:
                        _b.sent();
                        return [3, 8];
                    case 5: return [4, this.askDirPath()];
                    case 6:
                        _b.sent();
                        return [4, this.askSuffixOrPrefix()];
                    case 7:
                        _b.sent();
                        return [3, 8];
                    case 8: return [2];
                }
            });
        });
    };
    return Resizer;
}());
exports.default = Resizer;
new Resizer().main();
//# sourceMappingURL=index.js.map